class Turok3Interface {
    static FPSMAX { 0 }
    static FPS60 { 1 }
    static FPS30 { 2 }
    static FPS15 { 3 }
    static FPS60SCALE { 120 }
    static FPS30SCALE { 60 }
    static FPS15SCALE { 30 }
    static pCPlayerPointer { 0x8013DDB4 }
}

class CGameObjectInstance {
    construct new() {
        _base = 0
    }

    construct new(b_) {
        _base = b_
    }

    base { _base }
    base=(rhs) { _base = rhs }

    m_Type { base }
    m_vPos { base + 0x08}
    m_vVelocity { base + 0x1C }
    m_vScale { base + 0x50 }
    m_Rot { base + 0x5C }
    unk_m_vScale1 { base + 0x68 }
    m_RotY { base + 0x6C }
    m_vPos2 { base + 0xA4 }
    getEnd { base + 0x368 }
}

class CPlayer {
    construct new() {
        _base = 0
        _ca = CGameObjectInstance.new()
        _wa = CGameObjectInstance.new()
    }

    construct new(b_) {
        _base = b_
        _ca = CGameObjectInstance.new(b_)
        _wa = CGameObjectInstance.new(b_ + 0x368)
    }

    base { _base }
    base=(rhs) { _base = rhs }

    character { _ca }
    character=(rhs) {_ca = rhs}

    weapon { _wa }
    weapon=(rhs) {_wa = rhs}

    ca { base }
    wa { base + 0x368 }
    m_bActive { base + 0x6D0 }
    m_nController { base + 0x6D4 }
    m_pOptions { base + 0x6D8 }
    m_pCamera { base + 0x6DC }
    m_Mode { base + 0xCD2 }
    m_ModeBefore { base + 0xCD6 }
    m_ModeLastFrame { base + 0xCDA }
    m_ModeTime { base + 0xCDC }
    m_ModeLastFrameFlags { base + 0xCE0 }
    m_ModeBeforeFlags { base + 0xCE4 }
    m_ModeFlags {base + 0xCE8 }
    m_FrameIncrementScaled { base + 0xCF0 }
    m_Speed { base + 0xD60 }
    m_SideSpeed { base + 0xD64 }
    m_TotalSpeed { base + 0xD68 }
    m_YVelLastFrame { base + 0xD6C }
    m_bOnGround { base + 0xD70 }
    m_BurstSpeed { base + 0xD74 }
    m_BurstSideSpeed { base + 0xD78 }
    m_BurstTimer { base + 0xD7C }
    m_HandSide { base + 0xD80 }
    m_TimeOffGround { base + 0xD84 }
    m_vDesiredPos { base + 0xD88 }
    m_vDesiredPos2 { base + 0xD94 }
    m_DuckOffset { base + 0xDC4 }
    m_bDuckMode { base + 0xDC8 }
    unk_yOffset { base + 0xDCC }
    m_vHeadRotOffset { base + 0xDD0 }
    m_vHeadWobbleRotOffset { base + 0xDDC }
    m_vEyeOffset { base + 0xDE8 }
    m_BreathAmp { base + 0xE08 }
    m_RequestedWeapon { base + 0xE1E }
    m_vWeaponFirePos { base + 0xE24 }
    m_CrossHairMode { base + 0xEF4 }
    m_vOuterCrossHairPos { base + 0xEF8 }
    m_vOuterCrossHairVel { base + 0xF04 }
    m_pCrossHairTarget { base + 0xF10 }
    m_SightIcon { base + 0xF14 }
    m_SightIconFrame { base + 0xF18 }
    m_vCrossHairPos { base + 0xF1C }
    m_vCrossHairVel { base + 0xF28 }
    m_SniperMode { base + 0xF44 }
    unk_HasTarget { base + 0xF48 }
    m_ZoomBlend { base + 0xF54 }
    m_TargetZoomBlend { base + 0xF58 }
}



